Clarification of Segment ID Sub-TLV Length for RFC 8287
RFC 8690
Nagendra Kumar Nainar
Cisco Systems, Inc.
Carlos Pignataro
Cisco Systems, Inc.
Faisal Iqbal
Individual
Alexander Vainshtein
ECI Telecom
2019-12
Internet
Network Work group
mpls
RFC 8287 defines the extensions to perform LSP Ping and Traceroute for Segment Routing IGP-Prefix and IGP-Adjacency Segment Identifiers (SIDs) with the MPLS data plane. RFC 8287 proposes three Target Forwarding Equivalence Class (FEC) Stack sub-TLVs. While RFC 8287 defines the format and procedure to handle those sub-TLVs, it does not sufficiently clarify how the length of the Segment ID sub-TLVs should be computed to be included in the Length field of the sub-TLVs. This ambiguity has resulted in interoperability issues.
This document updates RFC 8287 by clarifying the length of each of the Segment ID sub-TLVs defined in RFC 8287.
Status of This Memo
This is an Internet Standards Track document.
This document is a product of the Internet Engineering Task Force (IETF). It represents the consensus of the IETF community. It has received public review and has been approved for publication by the Internet Engineering Steering Group (IESG). Further information on Internet Standards is available in Section 2 of RFC 7841.
Information about the current status of this document, any errata, and how to provide feedback on it may be obtained at https://www.rfc-editor.org/info/rfc8690.
Copyright Notice
Copyright (c) 2019 IETF Trust and the persons identified as the document authors. All rights reserved.
This document is subject to BCP 78 and the IETF Trust's Legal Provisions Relating to IETF Documents (https://trustee.ietf.org/license-info) in effect on the date of publication of this document. Please review these documents carefully, as they describe your rights and restrictions with respect to this document. Code Components extracted from this document must include Simplified BSD License text as described in Section 4.e of the Trust Legal Provisions and are provided without warranty as described in the Simplified BSD License.
Table of Contents
- 1. Introduction
- 2. Terminology
- 3. Requirements Notation
- 4. Length Field Clarification for Segment ID Sub-TLVs
  - 4.1. IPv4 IGP-Prefix Segment ID Sub-TLV
  - 4.2. IPv6 IGP-Prefix Segment ID Sub-TLV
  - 4.3. IGP-Adjacency Segment ID Sub-TLV
- 5. IANA Considerations
- 6. Security Considerations
- 7. Normative References
- Acknowledgements
- Contributors
- Authors' Addresses
Introduction
[RFC8287] defines the extensions to MPLS LSP Ping and Traceroute for Segment Routing IGP-Prefix and IGP-Adjacency Segment Identifiers (SIDs) with the MPLS data plane. [RFC8287] proposes three Target FEC Stack sub-TLVs. While RFC 8287 defines the format and procedure to handle those sub-TLVs, it does not sufficiently clarify how the length of the Segment ID sub-TLVs should be computed to be included in the Length field of the sub-TLVs, which may result in interoperability issues.
This document updates [RFC8287] by clarifying the length of each Segment ID sub-TLVs defined in [RFC8287].
Terminology
This document uses the terminology defined in [RFC8402], [RFC8029], and [RFC8287]; readers are expected to be familiar with the terms as used in those documents.
Requirements Notation
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Length Field Clarification for Segment ID Sub-TLVs
Section 5 of [RFC8287] defines three different Segment ID sub-TLVs that can be included in the Target FEC Stack TLV defined in [RFC8029].
The length of each sub-TLV MUST be calculated as defined in this section.
The TLV representations defined in Sections 5.1, 5.2, and 5.3 of [RFC8287] are updated to clarify the length calculations, as shown in Sections 4.1, 4.2, and 4.3, respectively. The updated TLV representations contain explicitly defined lengths.
IPv4 IGP-Prefix Segment ID Sub-TLV
The sub-TLV length for the IPv4 IGP-Prefix Segment ID MUST be set to 8, as shown in the TLV format below:

 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|Type = 34 (IPv4 IGP-Prefix SID)|          Length = 8           |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                          IPv4 prefix                          |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|Prefix Length  |    Protocol   |              Reserved         |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
IPv6 IGP-Prefix Segment ID Sub-TLV
The sub-TLV length for the IPv6 IGP-Prefix Segment ID MUST be set to 20, as shown in the TLV format below:

 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|Type = 35 (IPv6 IGP-Prefix SID)|          Length = 20          |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                                                               |
|                                                               |
|                       IPv6 Prefix                             |
|                                                               |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|Prefix Length  |    Protocol   |              Reserved         |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
IGP-Adjacency Segment ID Sub-TLV
The sub-TLV length for the IGP-Adjacency Segment ID varies depending on the Adjacency Type and Protocol. In any of the allowed combinations of Adjacency Type and Protocol, the sub-TLV length MUST be calculated by including 2 octets of the Reserved field. Table 1 lists the length for different combinations of Adj. Type and Protocol.
IGP-Adjacency SID Length Computation
Protocol | Length for Adj. Type
Parallel | IPv4 | IPv6 | Unnumbered
OSPF | 20 | 20 | 44 | 20
ISIS | 24 | 24 | 48 | 24
Any | 20 | 20 | 44 | 20
For example, when the Adj. Type is set to Parallel Adjacency and the Protocol is set to 0, the sub-TLV will be as below:

 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|Type = 36 (IGP-Adjacency SID)  |          Length = 20          |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
| Adj. Type = 1 | Protocol = 0  |          Reserved             |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|               Local Interface ID (4 octets)                   |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|              Remote Interface ID (4 octets)                   |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|          Advertising Node Identifier (4 octets)               |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|           Receiving Node Identifier (4 octets)                |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
IANA Considerations
IANA has listed this document as an additional reference for the following entries in the "Sub-TLVs for TLV Types 1, 16, and 21" registry:
Sub-TLVs for TLV Types 1, 16, and 21 (Updated Entries)
Sub-Type | Sub-TLV Name | Reference
34 | IPv4 IGP-Prefix Segment ID | Section 5.1 of [RFC8287]; RFC 8690
35 | IPv6 IGP-Prefix Segment ID | Section 5.2 of [RFC8287]; RFC 8690
36 | IGP-Adjacency Segment ID | Section 5.3 of [RFC8287]; RFC 8690
Security Considerations
This document updates [RFC8287] and does not introduce any additional security considerations.
Normative References
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC8029]

Detecting Multiprotocol Label Switched (MPLS) Data-Plane Failures
K. Kompella
G. Swallow
C. Pignataro, Ed.
N. Kumar
S. Aldrin
M. Chen
March 2017
RFC 8029
DOI 10.17487/RFC8029
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174
[RFC8287]

Label Switched Path (LSP) Ping/Traceroute for Segment Routing (SR) IGP-Prefix and IGP-Adjacency Segment Identifiers (SIDs) with MPLS Data Planes
N. Kumar, Ed.
C. Pignataro, Ed.
G. Swallow
N. Akiya
S. Kini
M. Chen
December 2017
RFC 8287
DOI 10.17487/RFC8287
[RFC8402]

Segment Routing Architecture
C. Filsfils, Ed.
S. Previdi, Ed.
L. Ginsberg
B. Decraene
S. Litkowski
R. Shakir
July 2018
RFC 8402
DOI 10.17487/RFC8402
Acknowledgements
The authors would like to thank Michael Gorokhovsky and Manohar Doppalapudi for investigating the interoperability issue during European Advanced Network Test Center (EANTC) testing.
Contributors
The following individual contributed to this document: Zafar Ali, Cisco Systems, Inc.
Authors' Addresses
Nagendra Kumar Nainar
Cisco Systems, Inc.
7200-12 Kit Creek Road
Research Triangle Park
NC
27709
United States of America
naikumar@cisco.com
Carlos Pignataro
Cisco Systems, Inc.
7200-11 Kit Creek Road
Research Triangle Park
NC
27709
United States of America
cpignata@cisco.com
Faisal Iqbal
Individual
Canada
faisal.ietf@gmail.com
Alexander Vainshtein
ECI Telecom
Israel
vainshtein.alex@gmail.com